#include "allegro5/allegro.h"
#include <string>
#include <list>

using namespace std;

#ifndef BMANAGER_H_INCLUDED
#define BMANAGER_H_INCLUDED

class Bitmap {
    protected:
        string name;
        ALLEGRO_BITMAP *bit;
    public:
        Bitmap(string nm, ALLEGRO_BITMAP *b);
        Bitmap(string nm);

        ALLEGRO_BITMAP *Get_Bit() {return bit;}
        void Set_Bit(ALLEGRO_BITMAP *b) {bit=b;}

        int Width() {if (bit) return al_get_bitmap_width(bit);}
        int Height() {if (bit) return al_get_bitmap_height(bit);}

        string Get_Name() {return name;}

        ~Bitmap() {if (bit) al_destroy_bitmap(bit);}
};

extern list<Bitmap *> cache_bitmaps;

Bitmap *Get_Bitmap(string nm);
ALLEGRO_BITMAP *Get_Allegro_Bitmap(string nm);
void Add_Bitmap(string nm, ALLEGRO_BITMAP *bit);



#endif
