#include "allegro5/allegro.h"
#include "allegro5/allegro_image.h"
#include "allegro5/allegro_primitives.h"
#include "allegro5/allegro_audio.h"
#include "allegro5/allegro_ttf.h"
#include "allegro5/allegro_font.h"
#include "allegro5/allegro_opengl.h"
#include <string>
#include <deque>
#include <list>
#include <vector>
#include <stdio.h>
#include "renderer.h"

using namespace std;

#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

const string DEFAULT_CONFIGURATION_PATH="game_config.ini";
const string DEFAULT_MISSING_BITMAP="data/missing.png";
const string DEFAULT_MISSING_SAMPLE="data/missing.ogg";
const string DEFAULT_LOG_PATH="game.log";

const float DEFAULT_INTERNAL_RES_W=1920;
const float DEFAULT_INTERNAL_RES_H=1080;

enum {
    SCENE_QUIT,
    SCENE_MENU,
    SCENE_GAME
};

void Menu_Tick(int);
void Game_Tick(int);

extern ALLEGRO_VOICE *voice;
extern ALLEGRO_MIXER *mixer;

extern Renderer *renderer;

extern int Scene;
extern int Game_Mode;

#endif
