#include "vobject.h"
#include <list>

#ifndef RENDERER_H_INCLUDED
#define RENDERER_H_INCLUDED

class Renderer {
    protected:
        ALLEGRO_DISPLAY *display;
        float x, y, width, height;
        float aspect_ratio;
        float internal_w, internal_h;
        float zoom;
    public:
        Renderer(ALLEGRO_DISPLAY *disp, float int_w, float int_h,  float w=0, float h=0, float tx=0, float ty=0);

        void Render(list<VObject *> *vobjects, float camera_x=0, float camera_y=0);
        void Sort_Z_List(list<VObject *> *vobjects);


        float Get_Width() {return width;}
        float Get_Height() {return height;}

        float XtoGX(float v);
        float YtoGY(float v);
        float GXtoX(float v);
        float GYtoY(float v);
        float XtoRX(float v);
        float YtoRY(float v);
        float RXtoX(float v);
        float RYtoY(float v);
        float XtoSX(float v);
        float YtoSX(float v);
};

#endif
