#include "allegro5/allegro.h"
#include "allegro5/allegro_audio.h"
#include <string>
#include <list>

using namespace std;

#ifndef SMANAGER_H_INCLUDED
#define SMANAGER_H_INCLUDED

class Sample {
    protected:
        string name;
        ALLEGRO_SAMPLE *sample;
    public:
        Sample(string nm, ALLEGRO_SAMPLE *s);
        Sample(string nm);

        ALLEGRO_SAMPLE *Get_Sample() {return sample;}
        void Set_Sample(ALLEGRO_SAMPLE *s) {sample=s;}

        void Play(float gain=1.0, float pan=0, float speed=1.0, ALLEGRO_PLAYMODE loop=ALLEGRO_PLAYMODE_ONCE);

        string Get_Name() {return name;}

        ~Sample() {if (sample) al_destroy_sample(sample);}
};

extern list<Sample *> cache_samples;

Sample *Get_Sample(string nm);
ALLEGRO_SAMPLE *Get_Allegro_Sample(string nm);
void Add_Sample(string nm, ALLEGRO_SAMPLE *sample);



#endif
