#include <stdio.h>
#include "allegro5/allegro.h"

using namespace std;

#ifndef VOBJECT_H_INCLUDED
#define VOBJECT_H_INCLUDED


class VObject {
    protected:
        float x, y, z, w, h;
        ALLEGRO_COLOR tint;
        float angle, c_x, c_y;
        ALLEGRO_BITMAP *actual_bit;
        int flags;
        bool visible;

        int index, row, type;
        float hurt_flash;

        int direction;

        int health, max_health;

        float a_life;
        float a_opacity;
        float a_speed;
        float a_angle;
        float a_angle_mod;

        bool delete_me;
        bool trigger;
    public:
        VObject(){}
        VObject(ALLEGRO_BITMAP *bit, float tx, float ty, float tw=0, float th=0);

        void Set_X(float v) {x=v;}
        float Get_X() {return x;}

        void Set_Y(float v) {y=v;}
        float Get_Y() {return y;}

        void Set_Z(float v) {z=v;}
        float Get_Z() {return z;}

        void Set_W(float v) {w=v;}
        float Get_W() {return w;}

        void Set_H(float v) {h=v;}
        float Get_H() {return h;}

        void Set_Angle(float v) {angle=v;}
        float Get_Angle() {return angle;}

        void Set_CX(float v) {c_x=v;}
        float Get_CX() {return c_x;}

        void Set_CY(float v) {c_y=v;}
        float Get_CY() {return c_y;}

        void Set_Flags(int v) {flags=v;}
        int Get_Flags() {return flags;}

        void Set_Tint(ALLEGRO_COLOR v) {tint=v;}
        ALLEGRO_COLOR Get_Tint() {return tint;}

        void Set_Index(int i) {index = i;}
        int Get_Index() {return index;}

        void Set_Actual_Bit(ALLEGRO_BITMAP *v) {actual_bit=v;}
        ALLEGRO_BITMAP *Get_Actual_Bit() {return actual_bit;}

        void Show() {visible = true;}
        void Hide() {visible = false;}
        bool Is_Visible() {return visible;}

        void Hurt() {hurt_flash=30;}
        float Get_Hurt_Flash() {return hurt_flash;}
        void Set_Hurt_Flash(float v) {hurt_flash=v;}

        void Set_Direction(int dir) {direction = dir;}
        int Get_Direction() {return direction;}

        void Set_Health(int v) {health=v; max_health=v;}
        int Get_Health() {return health;}
        void Reduce_Health() {health-=1;}

        void Set_Type(int v) {type=v;}
        int Get_Type() {return type;}

        float Get_A_Opacity() {return a_opacity;}

        void Set_Particle_Parameters(float a_l, float a_o, float a_s, float a_a, float a_m) {
            a_life=a_l;
            a_opacity=a_o;
            a_speed=a_s;
            a_angle=a_a;
            a_angle_mod=a_m;
        }

        void Update();

        bool To_Delete() {return delete_me;}

        int Get_Break_Opacity() {
            if (max_health==0) return 0;
            return 255-((float)health/(float)max_health)*255.0;
        }

        void Set_Trigger(bool v) {trigger = v;}
        bool Get_Trigger() {return trigger;}
};


#endif
