
#include "bitmap_manager.h"
#include "file.h"
#include "game.h"

list<Bitmap *> cache_bitmaps;

Bitmap::Bitmap(string nm) {
    name = nm;
    bit = NULL;

    bit = al_load_bitmap(nm.c_str());
    if (!bit) {
        printf("Bitmap %s couldn't be loaded. Is the file valid?\n", nm.c_str());
        al_set_new_bitmap_flags(ALLEGRO_MIN_LINEAR | ALLEGRO_MAG_LINEAR);
        bit = al_load_bitmap(DEFAULT_MISSING_BITMAP.c_str());
        if (!bit) {
            printf("The default missing bitmap couldn't be loaded either.");
            exit(1);
        }
    }
}

Bitmap::Bitmap(string nm, ALLEGRO_BITMAP *b) {
    name =nm;
    bit = b;
}



Bitmap *Get_Bitmap(string nm) {
    for (list<Bitmap *>::iterator it=cache_bitmaps.begin(); it!=cache_bitmaps.end(); it++) {
        if ((*it)->Get_Name() == nm) {
            return *it;
        }
    }

    Bitmap *b=new Bitmap(nm);
    cache_bitmaps.push_back(b);
    return b;
}

ALLEGRO_BITMAP *Get_Allegro_Bitmap(string nm) {
    Bitmap *b=Get_Bitmap(nm);
    if (b) return b->Get_Bit();
    return NULL;
}


void Add_Bitmap(string nm, ALLEGRO_BITMAP *bit) {
    cache_bitmaps.push_back(new Bitmap(nm, bit));
}
