
#include "config.h"
#include "file.h"
#include "stringlib.h"


Config::Config(string nm) {
    name = nm;
    if (File_Exists(name)) {
        cfg = al_load_config_file(name.c_str());
    }
    else {
        cfg = al_create_config();
    }
}


void Config::Save() {
    al_save_config_file(name.c_str(), cfg);
}


void Config::Set_Float(string section, string name, float v) {
    if (!cfg) return;
    Set_String(section, name, ToString(v));
}

void Config::Set_String(string section, string name, string v) {
    if (!cfg) return;
    al_set_config_value(cfg, section.c_str(), name.c_str(), v.c_str());
}



float Config::Get_Float(string section, string name, float def) {
    if (!cfg) return 0;

    char *v=(char *)al_get_config_value(cfg, section.c_str(), name.c_str());
    if (!v) {
        Set_Float(section, name, def);
        return def;
    }
    else return ToFloat(v);
}


string Config::Get_String(string section, string name, string def) {
    if (!cfg) return "";

    char *v=(char *)al_get_config_value(cfg, section.c_str(), name.c_str());
    if (!v) {
        Set_String(section, name, def);
        return def;
    }
    else return ToString(v);
}


vector<string> Config::Get_Sections() {
    ALLEGRO_CONFIG_SECTION *iterator;
    vector<string> list;
    list.clear();

    char *name;
    name = (char *) al_get_first_config_section(cfg, &iterator);
    if (name) {
        list.push_back(name);
    }
    while (name = (char *) al_get_next_config_section(&iterator)) list.push_back(name);

    return list;
}
