#include "game.h"
#include "bitmap_manager.h"
#include "inputlib.h"

float black_screen_opacity=0;

ALLEGRO_FONT *menu_font;
int menu_option=0;

void Create_Menu() {
    menu_font=al_load_font("data/font.ttf", (104.0/1080.0)*renderer->Get_Height(), 0);
}

void Update_Menu() {
    if (KB_Input[ALLEGRO_KEY_UP]) menu_option -= 1;
    if (KB_Input[ALLEGRO_KEY_DOWN]) menu_option += 1;

    if (menu_option < 0) menu_option=2;
    if (menu_option > 2) menu_option=0;

    if (KB_Input[ALLEGRO_KEY_ENTER]) {
        if (menu_option==0) {
            Scene = SCENE_GAME;
            Game_Mode=0;
        }

        if (menu_option==1) {
            Scene = SCENE_GAME;
            Game_Mode=1;
        }

        if (menu_option==2) Scene = SCENE_QUIT;
    }
}

void Draw_Menu() {

    ALLEGRO_BITMAP *bit;
    bit = Get_Allegro_Bitmap("data/background.png");
    al_draw_scaled_bitmap(bit, 0, 0, al_get_bitmap_width(bit), al_get_bitmap_height(bit), 0, 0, renderer->Get_Width(), renderer->Get_Height(), 0);


    bit = Get_Allegro_Bitmap("data/logo.png");
    al_draw_scaled_bitmap(bit, 0, 0, al_get_bitmap_width(bit), al_get_bitmap_height(bit), renderer->Get_Width()/2-renderer->XtoRX(al_get_bitmap_width(bit)/2), renderer->YtoRY(40), renderer->XtoRX(al_get_bitmap_width(bit)), renderer->XtoRX(al_get_bitmap_height(bit)), 0);

    bit = Get_Allegro_Bitmap("data/shlogo.png");
    al_draw_scaled_bitmap(bit, 0, 0, al_get_bitmap_width(bit), al_get_bitmap_height(bit),
                            renderer->Get_Width()-renderer->XtoRX(al_get_bitmap_width(bit)), renderer->YtoRY(1080-al_get_bitmap_height(bit)),
                            renderer->XtoRX(al_get_bitmap_width(bit)), renderer->XtoRX(al_get_bitmap_height(bit)), 0);

    ALLEGRO_COLOR color;
    color = (menu_option==0 ? al_map_rgb(255, 255, 255) : al_map_rgb(75, 75, 75));
    al_draw_textf(menu_font, color, renderer->Get_Width()/2, renderer->YtoRY(500), ALLEGRO_ALIGN_CENTRE, "Arcade Mode");

    color = (menu_option==1 ? al_map_rgb(255, 255, 255) : al_map_rgb(75, 75, 75));
    al_draw_textf(menu_font, color, renderer->Get_Width()/2, renderer->YtoRY(620), ALLEGRO_ALIGN_CENTRE, "Puzzle Mode");

    color = (menu_option==2 ? al_map_rgb(255, 255, 255) : al_map_rgb(75, 75, 75));
    al_draw_textf(menu_font, color, renderer->Get_Width()/2, renderer->YtoRY(740), ALLEGRO_ALIGN_CENTRE, "Exit");


    al_draw_filled_rectangle(0, 0, renderer->Get_Width(), renderer->Get_Height(), al_map_rgba(0,0,0,255-black_screen_opacity));

}


void Menu_Tick(int Last_Scene) {
    if (Last_Scene != Scene) Create_Menu();
    Update_Menu();
    Draw_Menu();

    black_screen_opacity += 2;
    if (black_screen_opacity > 255) black_screen_opacity = 255;
}
