
#include "sound_manager.h"
#include "file.h"
#include "game.h"

list<Sample *> cache_samples;

Sample::Sample(string nm) {
    name = nm;
    sample = NULL;

    sample = al_load_sample(nm.c_str());
    if (!sample) {
        printf("Sample %s couldn't be loaded. Is the file valid?\n", nm.c_str());
        sample = al_load_sample(DEFAULT_MISSING_SAMPLE.c_str());
        if (!sample) {
            printf("The default missing sample couldn't be loaded either.");
            exit(1);
        }
    }
}

Sample::Sample(string nm, ALLEGRO_SAMPLE *s) {
    name =nm;
    sample = s;
}

void Sample::Play(float gain, float pan, float speed, ALLEGRO_PLAYMODE loop) {
    assert(sample);

    al_play_sample(sample, gain, pan, speed, loop, NULL);
}



Sample *Get_Sample(string nm) {
    for (list<Sample *>::iterator it=cache_samples.begin(); it!=cache_samples.end(); it++) {
        if ((*it)->Get_Name() == nm) {
            return *it;
        }
    }

    Sample *s=new Sample(nm);
    cache_samples.push_back(s);
    return s;
}

ALLEGRO_SAMPLE *Get_Allegro_Sample(string nm) {
    Sample *s=Get_Sample(nm);
    if (s) return s->Get_Sample();
    return NULL;
}


void Add_Sample(string nm, ALLEGRO_SAMPLE *s) {
    cache_samples.push_back(new Sample(nm, s));
}
