
#include "vobject.h"
#include <math.h>


VObject::VObject(ALLEGRO_BITMAP *bit, float tx, float ty, float tw, float th) {
    actual_bit = bit;
    assert(actual_bit);

    x = tx;
    y = ty;
    w = tw;
    h = th;
    z = 0;

    if (w <= 0) w = al_get_bitmap_width(actual_bit);
    if (h <= 0) h = al_get_bitmap_height(actual_bit);

    tint = al_map_rgb(255, 255, 255);
    angle = 0;
    c_x = al_get_bitmap_width(actual_bit)/2;
    c_y = al_get_bitmap_height(actual_bit)/2;


    flags = 0;
    visible = true;

    hurt_flash = 0;
    type = 0;

    health=max_health=0;
    index=0;

    a_life=a_opacity=a_speed=a_angle=a_angle_mod=-1;

    delete_me=false;
    trigger=false;
}

void VObject::Update() {
    if (hurt_flash > 0) {
        hurt_flash-=1;
        if (((int)hurt_flash/4)%2) tint = al_map_rgb(500, 500, 500);
        else tint = al_map_rgb(100, 155, 200);
    }
    else {
        tint = al_map_rgb(255, 255, 255);
    }

    if (a_life > 0) {
        a_life -= 1;
        a_opacity -= 5;

        if (a_opacity < 0) {
            a_opacity = 0;
            visible = false;
        }

        tint = al_map_rgba(255, 255, 255, a_opacity);

        x += cos(a_angle)*a_speed;
        y += sin(a_angle)*a_speed;

        a_angle += a_angle_mod;
    }

    if (a_life == 0) {
        delete_me=true;
    }
}
